diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java
similarity index 74%
rename from src/main/java/net/minecraft/client/render/RenderBlocks.java
rename to game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java
index 2e169bec0..e3f4f1b23 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.render;
 
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.phys.AABB;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
@@ -61,7 +63,7 @@ public class RenderBlocks
             return block.getBlockBrightness(blockAccess, x, y, z);
         }
 
-        return blockAccess.getBrightness(x, y, z, Block.lightEmission[id]);
+        return blockAccess.getBrightness(x, y, z, Blocks.lightEmission[id]);
     }
 
 	public void renderBlockFallingSand(Tessellator tessellator, BlockModel<Block> blockModel, Block block, WorldSource world, int x, int y, int z) {
@@ -86,7 +88,9 @@ public class RenderBlocks
 		float brightness = 1.0f;
 		
 		final int lmcInside = lightmap ? block.getLightmapCoord(world, x, y, z) : 0;
-		
+
+        final AABB bounds = block.getBounds();
+
 		// Bottom
 		if(lightmap) {
 			tessellator.setLightmapCoord(LightmapHelper.max(lmcInside, block.getLightmapCoord(world, x, y - 1, z)));
@@ -94,7 +98,7 @@ public class RenderBlocks
 			brightness = Math.max(getBlockBrightness(world, x, y - 1, z), brightnessInside);
 		}
 		tessellator.setColorOpaque_F(sideBottom * brightness, sideBottom * brightness, sideBottom * brightness);
-		renderBottomFace(tessellator, block, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.BOTTOM, meta));
+		renderBottomFace(tessellator, bounds, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.BOTTOM, meta));
 		
 		// Top
 		if(lightmap) {
@@ -103,7 +107,7 @@ public class RenderBlocks
 			brightness = Math.max(getBlockBrightness(world, x, y + 1, z), brightnessInside);	
 		}
 		tessellator.setColorOpaque_F(sideTop * brightness, sideTop * brightness, sideTop * brightness);
-		renderTopFace(tessellator, block, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.TOP, meta));
+		renderTopFace(tessellator, bounds, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.TOP, meta));
 		
 		// North
 		if(lightmap) {
@@ -112,7 +116,7 @@ public class RenderBlocks
 			brightness = Math.max(getBlockBrightness(world, x, y, z - 1), brightnessInside);
 		}
 		tessellator.setColorOpaque_F(sideNorthSouth * brightness, sideNorthSouth * brightness, sideNorthSouth * brightness);
-		renderNorthFace(tessellator, block, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.NORTH, meta));
+		renderNorthFace(tessellator, bounds, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.NORTH, meta));
 		
 		// South
 		if(lightmap) {
@@ -121,7 +125,7 @@ public class RenderBlocks
 			brightness = Math.max(getBlockBrightness(world, x, y, z + 1), brightnessInside);
 		}
 		tessellator.setColorOpaque_F(sideNorthSouth * brightness, sideNorthSouth * brightness, sideNorthSouth * brightness);
-		renderSouthFace(tessellator, block, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.SOUTH, meta));
+		renderSouthFace(tessellator, bounds, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.SOUTH, meta));
 		
 		// West
 		if(lightmap) {
@@ -130,7 +134,7 @@ public class RenderBlocks
 			brightness = Math.max(getBlockBrightness(world, x - 1, y, z), brightnessInside);
 		}
 		tessellator.setColorOpaque_F(sideEastWest * brightness, sideEastWest * brightness, sideEastWest * brightness);
-		renderWestFace(tessellator, block, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.WEST, meta));
+		renderWestFace(tessellator, bounds, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.WEST, meta));
 		
 		// East
 		if(lightmap) {
@@ -139,80 +143,80 @@ public class RenderBlocks
 			brightness = Math.max(getBlockBrightness(world, x + 1, y, z), brightnessInside);
 		}
 		tessellator.setColorOpaque_F(sideEastWest * brightness, sideEastWest * brightness, sideEastWest * brightness);
-		renderEastFace(tessellator, block, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.EAST, meta));
+		renderEastFace(tessellator, bounds, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.EAST, meta));
 		
 		tessellator.draw();
 	}
 
-    public boolean renderStandardBlock(Tessellator tessellator, BlockModel<Block> blockModel, Block block, int x, int y, int z)
+    public boolean renderStandardBlock(Tessellator tessellator, BlockModel<Block> blockModel, AABB bounds, int x, int y, int z)
     {
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(blockAccess, x, y, z);
+        int color = BlockColorDispatcher.getInstance().getDispatch(blockModel.block).getWorldColor(blockAccess, x, y, z);
         float r = (float)(color >> 16 & 0xff) / 255F;
         float g = (float)(color >> 8 & 0xff) / 255F;
         float b = (float)(color & 0xff) / 255F;
-        return renderStandardBlock(tessellator, blockModel, block, x, y, z, r, g, b);
+        return renderStandardBlock(tessellator, blockModel, bounds, x, y, z, r, g, b);
     }
 
     /**
      * @author CyborgCabbage
      * Thanks! :D
      */
-    public boolean renderStandardBlock(Tessellator tessellator, BlockModel<Block> blockModel, Block block, int x, int y, int z, float r, float g, float b) {
+    public boolean renderStandardBlock(Tessellator tessellator, BlockModel<Block> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b) {
         this.enableAO = true;
         int meta = blockAccess.getBlockMetadata(x, y, z);
-        cache.setupCache(block, blockAccess, x, y, z);
+        cache.setupCache(blockModel.block, blockAccess, x, y, z);
         boolean somethingRendered = false;
         for (Side side : Side.sides){
-            somethingRendered |= renderSide(tessellator, blockModel, block, x, y, z, r, g, b, side, meta);
+            somethingRendered |= renderSide(tessellator, blockModel, bounds, x, y, z, r, g, b, side, meta);
         }
         this.enableAO = false;
         return somethingRendered;
     }
-    public final boolean renderSide(Tessellator tessellator, BlockModel<Block> blockModel, Block block, int x, int y, int z, float r, float g, float b, Side side, int meta){
+    public final boolean renderSide(Tessellator tessellator, BlockModel<Block> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b, Side side, int meta){
         boolean useColor;
         switch (side){
             case BOTTOM:
                 useColor = blockModel.shouldSideBeColored(blockAccess, x, y, z, 0, meta);
-                return renderSide(tessellator, blockModel, block, x, y, z,
+                return renderSide(tessellator, blockModel, bounds, x, y, z,
                         useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,0, meta,
-                        0, -1, 0, (float)block.minY,
-                        0, 0, 1, (float)block.maxZ, (float)block.minZ,
-                        -1, 0, 0, 1-(float)block.minX, 1-(float)block.maxX);
+                        0, -1, 0, (float)bounds.minY,
+                        0, 0, 1, (float)bounds.maxZ, (float)bounds.minZ,
+                        -1, 0, 0, 1-(float)bounds.minX, 1-(float)bounds.maxX);
             case TOP:
                 useColor = blockModel.shouldSideBeColored(blockAccess, x, y, z, 1, meta);
-                return renderSide(tessellator, blockModel, block, x, y, z,
+                return renderSide(tessellator, blockModel, bounds, x, y, z,
                         useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,1, meta,
-                        0,1,0, 1-(float)block.maxY,
-                        0,0,1, (float)block.maxZ, (float)block.minZ,
-                        1,0,0, (float)block.maxX, (float)block.minX);
+                        0,1,0, 1-(float)bounds.maxY,
+                        0,0,1, (float)bounds.maxZ, (float)bounds.minZ,
+                        1,0,0, (float)bounds.maxX, (float)bounds.minX);
             case NORTH:
                 useColor = blockModel.shouldSideBeColored(blockAccess, x, y, z, 2, meta);
-                return renderSide(tessellator, blockModel, block, x, y, z,
+                return renderSide(tessellator, blockModel, bounds, x, y, z,
                         useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,2, meta,
-                        0,0,-1, (float)block.minZ,
-                        -1,0,0, 1-(float)block.minX, 1-(float)block.maxX,
-                        0,1,0, (float)block.maxY, (float)block.minY);
+                        0,0,-1, (float)bounds.minZ,
+                        -1,0,0, 1-(float)bounds.minX, 1-(float)bounds.maxX,
+                        0,1,0, (float)bounds.maxY, (float)bounds.minY);
             case SOUTH:
                 useColor = blockModel.shouldSideBeColored(blockAccess, x, y, z, 3, meta);
-                return renderSide(tessellator, blockModel, block, x, y, z,
+                return renderSide(tessellator, blockModel, bounds, x, y, z,
                         useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,3, meta,
-                        0,0,1, 1-(float)block.maxZ,
-                        0,1,0, (float)block.maxY, (float)block.minY,
-                        -1,0,0, 1-(float)block.minX, 1-(float)block.maxX);
+                        0,0,1, 1-(float)bounds.maxZ,
+                        0,1,0, (float)bounds.maxY, (float)bounds.minY,
+                        -1,0,0, 1-(float)bounds.minX, 1-(float)bounds.maxX);
             case WEST:
                 useColor = blockModel.shouldSideBeColored(blockAccess, x, y, z, 4, meta);
-                return renderSide(tessellator, blockModel, block, x, y, z,
+                return renderSide(tessellator, blockModel, bounds, x, y, z,
                         useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,4, meta,
-                        -1,0,0, (float)block.minX,
-                        0,0,1, (float)block.maxZ, (float)block.minZ,
-                        0,1,0, (float)block.maxY, (float)block.minY);
+                        -1,0,0, (float)bounds.minX,
+                        0,0,1, (float)bounds.maxZ, (float)bounds.minZ,
+                        0,1,0, (float)bounds.maxY, (float)bounds.minY);
             case EAST:
                 useColor = blockModel.shouldSideBeColored(blockAccess, x, y, z, 5, meta);
-                return renderSide(tessellator, blockModel, block, x, y, z,
+                return renderSide(tessellator, blockModel, bounds, x, y, z,
                         useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,5, meta,
-                        1,0,0, 1-(float)block.maxX,
-                        0,0,1, (float)block.maxZ, (float)block.minZ,
-                        0,-1,0, 1-(float)block.minY, 1-(float)block.maxY);
+                        1,0,0, 1-(float)bounds.maxX,
+                        0,0,1, (float)bounds.maxZ, (float)bounds.minZ,
+                        0,-1,0, 1-(float)bounds.minY, 1-(float)bounds.maxY);
             default:
                 throw new IllegalArgumentException("Side " + side + " not expected!");
         }
@@ -222,7 +226,7 @@ public class RenderBlocks
      * @author CyborgCabbage
      * Thanks! :D
      */
-    public final boolean renderSide(Tessellator tessellator, BlockModel<Block> blockModel, Block block, int x, int y, int z, float r, float g, float b, int side, int meta,
+    public final boolean renderSide(Tessellator tessellator, BlockModel<Block> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b, int side, int meta,
                                     int dirX, int dirY, int dirZ, float depth,
                                     int topX, int topY, int topZ, float topP, float botP,
                                     int lefX, int lefY, int lefZ, float lefP, float rigP
@@ -236,26 +240,25 @@ public class RenderBlocks
         if (tex == null || ((renderBitMask >> side) & 1) != 0) return false;
 
         boolean rendered = false;
-        block.setBlockBoundsBasedOnSide(this.blockAccess, x, y, z, Side.getSideById(side));
-        if (this.renderAllFaces || blockModel.shouldSideBeRendered(this.blockAccess, x+dirX, y+dirY, z+dirZ, side, meta)) {
+        if (this.renderAllFaces || blockModel.shouldSideBeRendered(this.blockAccess, bounds, x+dirX, y+dirY, z+dirZ, side, meta)) {
         	
-            setupLighting(block, x, y, z, r, g, b, side, meta,
+            setupLighting(blockModel.block, x, y, z, r, g, b, side, meta,
                     dirX, dirY, dirZ, depth,
                     topX, topY, topZ, topP, botP,
                     lefX, lefY, lefZ, lefP, rigP);
 
             if (side == 0) {
-                this.renderBottomFace(tessellator, block, x, y, z, tex);
+                this.renderBottomFace(tessellator, bounds, x, y, z, tex);
             } else if (side == 1) {
-                this.renderTopFace(tessellator, block, x, y, z, tex);
+                this.renderTopFace(tessellator, bounds, x, y, z, tex);
             } else if (side == 2) {
-                this.renderNorthFace(tessellator, block, x, y, z, tex);
+                this.renderNorthFace(tessellator, bounds, x, y, z, tex);
             } else if (side == 3) {
-                this.renderSouthFace(tessellator, block, x, y, z, tex);
+                this.renderSouthFace(tessellator, bounds, x, y, z, tex);
             } else if (side == 4) {
-                this.renderWestFace(tessellator, block, x, y, z, tex);
+                this.renderWestFace(tessellator, bounds, x, y, z, tex);
             } else if (side == 5) {
-                this.renderEastFace(tessellator, block, x, y, z, tex);
+                this.renderEastFace(tessellator, bounds, x, y, z, tex);
             }
             rendered = true;
         }
@@ -265,7 +268,7 @@ public class RenderBlocks
                                     int dirX, int dirY, int dirZ, float depth,
                                     int topX, int topY, int topZ, float topP, float botP,
                                     int lefX, int lefY, int lefZ, float lefP, float rigP){
-    	boolean ao = mc.isAmbientOcclusionEnabled() && Block.lightEmission[block.id] == 0;
+    	boolean ao = mc.isAmbientOcclusionEnabled() && Blocks.lightEmission[block.id] == 0;
         boolean isFullCube = depth <= FULL_CUBE_THRESHOLD;
 
     	if(LightmapHelper.isLightmapEnabled()) {
@@ -438,20 +441,20 @@ public class RenderBlocks
         this.colorBlueTopRight *= ltr;
     }
 
-    public void renderBottomFace(Tessellator tessellator, Block block, double x, double y, double z, IconCoordinate tex)
+    public void renderBottomFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex)
     {
         if(overrideBlockTexture != null) tex = overrideBlockTexture;
         if (tex == null) return;
-        double d3 = tex.getSubIconU(block.minX);
-        double d4 = tex.getSubIconU(block.maxX);
-        double d5 = tex.getSubIconV(block.minZ);
-        double d6 = tex.getSubIconV(block.maxZ);
-        if(block.minX < 0.0D || block.maxX > 1.0D)
+        double d3 = tex.getSubIconU(bounds.minX);
+        double d4 = tex.getSubIconU(bounds.maxX);
+        double d5 = tex.getSubIconV(bounds.minZ);
+        double d6 = tex.getSubIconV(bounds.maxZ);
+        if(bounds.minX < 0.0D || bounds.maxX > 1.0D)
         {
             d3 = tex.getIconUMin();
             d4 = tex.getIconUMax();
         }
-        if(block.minZ < 0.0D || block.maxZ > 1.0D)
+        if(bounds.minZ < 0.0D || bounds.maxZ > 1.0D)
         {
             d5 = tex.getIconVMin();
             d6 = tex.getIconVMax();
@@ -462,10 +465,10 @@ public class RenderBlocks
         double d10 = d6;
         if(uvRotateBottom == 2)
         {
-            d3 = tex.getSubIconU(block.minX);
-            d5 = tex.getSubIconV(1 - block.maxX);
-            d4 = tex.getSubIconU(block.maxZ);
-            d6 = tex.getSubIconV(1 - block.minZ);
+            d3 = tex.getSubIconU(bounds.minX);
+            d5 = tex.getSubIconV(1 - bounds.maxX);
+            d4 = tex.getSubIconU(bounds.maxZ);
+            d6 = tex.getSubIconV(1 - bounds.minZ);
             d9 = d5;
             d10 = d6;
             d7 = d3;
@@ -475,10 +478,10 @@ public class RenderBlocks
         } else
         if(uvRotateBottom == 1)
         {
-            d3 = tex.getSubIconU(1 - block.maxZ);
-            d5 = tex.getSubIconV(block.minX);
-            d4 = tex.getSubIconU(1 - block.minZ);
-            d6 = tex.getSubIconV(block.maxX);
+            d3 = tex.getSubIconU(1 - bounds.maxZ);
+            d5 = tex.getSubIconV(bounds.minX);
+            d4 = tex.getSubIconU(1 - bounds.minZ);
+            d6 = tex.getSubIconV(bounds.maxX);
             d7 = d4;
             d8 = d3;
             d3 = d7;
@@ -488,20 +491,20 @@ public class RenderBlocks
         } else
         if(uvRotateBottom == 3)
         {
-            d3 = tex.getSubIconU(1 - block.maxX);
-            d4 = tex.getSubIconU(1 - block.minX);
-            d5 = tex.getSubIconV(1 - block.minZ);
-            d6 = tex.getSubIconV(1 - block.maxZ);
+            d3 = tex.getSubIconU(1 - bounds.maxX);
+            d4 = tex.getSubIconU(1 - bounds.minX);
+            d5 = tex.getSubIconV(1 - bounds.minZ);
+            d6 = tex.getSubIconV(1 - bounds.maxZ);
             d7 = d4;
             d8 = d3;
             d9 = d5;
             d10 = d6;
         }
-        double d11 = x + block.minX;
-        double d12 = x + block.maxX;
-        double d13 = y + block.minY;
-        double d14 = z + block.minZ;
-        double d15 = z + block.maxZ;
+        double d11 = x + bounds.minX;
+        double d12 = x + bounds.maxX;
+        double d13 = y + bounds.minY;
+        double d14 = z + bounds.minZ;
+        double d15 = z + bounds.maxZ;
         if(enableAO)
         {
         	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
@@ -525,20 +528,20 @@ public class RenderBlocks
         }
     }
 
-    public void renderTopFace(Tessellator tessellator, Block block, double x, double y, double z, IconCoordinate tex)
+    public void renderTopFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex)
     {
         if(overrideBlockTexture != null) tex = overrideBlockTexture;
         if (tex == null) return;
-        double d3 = tex.getSubIconU(block.minX);
-        double d4 = tex.getSubIconU(block.maxX);
-        double d5 = tex.getSubIconV(block.minZ);
-        double d6 = tex.getSubIconV(block.maxZ);
-        if(block.minX < 0.0D || block.maxX > 1.0D)
+        double d3 = tex.getSubIconU(bounds.minX);
+        double d4 = tex.getSubIconU(bounds.maxX);
+        double d5 = tex.getSubIconV(bounds.minZ);
+        double d6 = tex.getSubIconV(bounds.maxZ);
+        if(bounds.minX < 0.0D || bounds.maxX > 1.0D)
         {
             d3 = tex.getIconUMin();
             d4 = tex.getIconUMax();
         }
-        if(block.minZ < 0.0D || block.maxZ > 1.0D)
+        if(bounds.minZ < 0.0D || bounds.maxZ > 1.0D)
         {
             d5 = tex.getIconVMin();
             d6 = tex.getIconVMax();
@@ -549,10 +552,10 @@ public class RenderBlocks
         double d10 = d6;
         if(uvRotateTop == 1)
         {
-            d3 = tex.getSubIconU(block.minZ);
-            d5 = tex.getSubIconV(1 - block.maxX);
-            d4 = tex.getSubIconU(block.maxZ);
-            d6 = tex.getSubIconV(1 - block.minX);
+            d3 = tex.getSubIconU(bounds.minZ);
+            d5 = tex.getSubIconV(1 - bounds.maxX);
+            d4 = tex.getSubIconU(bounds.maxZ);
+            d6 = tex.getSubIconV(1 - bounds.minX);
             d9 = d5;
             d10 = d6;
             d7 = d3;
@@ -562,10 +565,10 @@ public class RenderBlocks
         } else
         if(uvRotateTop == 2)
         {
-            d3 = tex.getSubIconU(1 - block.maxZ);
-            d5 = tex.getSubIconV(block.minX);
-            d4 = tex.getSubIconU(1 - block.minZ);
-            d6 = tex.getSubIconV(block.maxX);
+            d3 = tex.getSubIconU(1 - bounds.maxZ);
+            d5 = tex.getSubIconV(bounds.minX);
+            d4 = tex.getSubIconU(1 - bounds.minZ);
+            d6 = tex.getSubIconV(bounds.maxX);
             d7 = d4;
             d8 = d3;
             d3 = d7;
@@ -575,20 +578,20 @@ public class RenderBlocks
         } else
         if(uvRotateTop == 3)
         {
-            d3 = tex.getSubIconU(1 - block.minX);
-            d4 = tex.getSubIconU(1 - block.maxX);
-            d5 = tex.getSubIconV(1 - block.minZ);
-            d6 = tex.getSubIconV(1 - block.maxZ);
+            d3 = tex.getSubIconU(1 - bounds.minX);
+            d4 = tex.getSubIconU(1 - bounds.maxX);
+            d5 = tex.getSubIconV(1 - bounds.minZ);
+            d6 = tex.getSubIconV(1 - bounds.maxZ);
             d7 = d4;
             d8 = d3;
             d9 = d5;
             d10 = d6;
         }
-        double d11 = x + block.minX;
-        double d12 = x + block.maxX;
-        double d13 = y + block.maxY;
-        double d14 = z + block.minZ;
-        double d15 = z + block.maxZ;
+        double d11 = x + bounds.minX;
+        double d12 = x + bounds.maxX;
+        double d13 = y + bounds.maxY;
+        double d14 = z + bounds.minZ;
+        double d15 = z + bounds.maxZ;
         if(enableAO)
         {
         	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
@@ -612,26 +615,26 @@ public class RenderBlocks
         }
     }
 
-    public void renderNorthFace(Tessellator tessellator, Block block, double x, double y, double z, IconCoordinate tex)
+    public void renderNorthFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex)
     {
         if(overrideBlockTexture != null) tex = overrideBlockTexture;
         if (tex == null) return;
-        double d3 = tex.getSubIconU(block.minX);
-        double d4 = tex.getSubIconU(block.maxX);
-        double d5 = tex.getSubIconV(1 - block.maxY);
-        double d6 = tex.getSubIconV(1 - block.minY);
+        double d3 = tex.getSubIconU(bounds.minX);
+        double d4 = tex.getSubIconU(bounds.maxX);
+        double d5 = tex.getSubIconV(1 - bounds.maxY);
+        double d6 = tex.getSubIconV(1 - bounds.minY);
         if(flipTexture)
         {
             double d7 = d3;
             d3 = d4;
             d4 = d7;
         }
-        if(block.minX < 0.0D || block.maxX > 1.0D)
+        if(bounds.minX < 0.0D || bounds.maxX > 1.0D)
         {
             d3 = tex.getIconUMin();
             d4 = tex.getIconUMax();
         }
-        if(block.minY < 0.0D || block.maxY > 1.0D)
+        if(bounds.minY < 0.0D || bounds.maxY > 1.0D)
         {
             d5 = tex.getIconVMin();
             d6 = tex.getIconVMax();
@@ -642,10 +645,10 @@ public class RenderBlocks
         double d11 = d6;
         if(uvRotateEast == 2)
         {
-            d3 = tex.getSubIconU(block.minY);
-            d5 = tex.getSubIconV(1 - block.minX);
-            d4 = tex.getSubIconU(block.maxY);
-            d6 = tex.getSubIconV(1 - block.maxX);
+            d3 = tex.getSubIconU(bounds.minY);
+            d5 = tex.getSubIconV(1 - bounds.minX);
+            d4 = tex.getSubIconU(bounds.maxY);
+            d6 = tex.getSubIconV(1 - bounds.maxX);
             d10 = d5;
             d11 = d6;
             d8 = d3;
@@ -655,10 +658,10 @@ public class RenderBlocks
         } else
         if(uvRotateEast == 1)
         {
-            d3 = tex.getSubIconU(1 - block.maxY);
-            d5 = tex.getSubIconV(block.maxX);
-            d4 = tex.getSubIconU(1 - block.minY);
-            d6 = tex.getSubIconV(block.minX);
+            d3 = tex.getSubIconU(1 - bounds.maxY);
+            d5 = tex.getSubIconV(bounds.maxX);
+            d4 = tex.getSubIconU(1 - bounds.minY);
+            d6 = tex.getSubIconV(bounds.minX);
             d8 = d4;
             d9 = d3;
             d3 = d8;
@@ -668,20 +671,20 @@ public class RenderBlocks
         } else
         if(uvRotateEast == 3)
         {
-            d3 = tex.getSubIconU(1 - block.minX);
-            d4 = tex.getSubIconU(1 - block.maxX);
-            d5 = tex.getSubIconV(block.maxY);
-            d6 = tex.getSubIconV(block.minY);
+            d3 = tex.getSubIconU(1 - bounds.minX);
+            d4 = tex.getSubIconU(1 - bounds.maxX);
+            d5 = tex.getSubIconV(bounds.maxY);
+            d6 = tex.getSubIconV(bounds.minY);
             d8 = d4;
             d9 = d3;
             d10 = d5;
             d11 = d6;
         }
-        double d12 = x + block.minX;
-        double d13 = x + block.maxX;
-        double d14 = y + block.minY;
-        double d15 = y + block.maxY;
-        double d16 = z + block.minZ;
+        double d12 = x + bounds.minX;
+        double d13 = x + bounds.maxX;
+        double d14 = y + bounds.minY;
+        double d15 = y + bounds.maxY;
+        double d16 = z + bounds.minZ;
         if(enableAO)
         {
         	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
@@ -705,26 +708,26 @@ public class RenderBlocks
         }
     }
 
-    public void renderSouthFace(Tessellator tessellator, Block block, double x, double y, double z, IconCoordinate tex)
+    public void renderSouthFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex)
     {
         if(overrideBlockTexture != null) tex = overrideBlockTexture;
         if (tex == null) return;
-        double d3 = tex.getSubIconU(block.minX);
-        double d4 = tex.getSubIconU(block.maxX);
-        double d5 = tex.getSubIconV(1 - block.maxY);
-        double d6 = tex.getSubIconV(1 - block.minY);
+        double d3 = tex.getSubIconU(bounds.minX);
+        double d4 = tex.getSubIconU(bounds.maxX);
+        double d5 = tex.getSubIconV(1 - bounds.maxY);
+        double d6 = tex.getSubIconV(1 - bounds.minY);
         if(flipTexture)
         {
             double d7 = d3;
             d3 = d4;
             d4 = d7;
         }
-        if(block.minX < 0.0D || block.maxX > 1.0D)
+        if(bounds.minX < 0.0D || bounds.maxX > 1.0D)
         {
             d3 = tex.getIconUMin();
             d4 = tex.getIconUMax();
         }
-        if(block.minY < 0.0D || block.maxY > 1.0D)
+        if(bounds.minY < 0.0D || bounds.maxY > 1.0D)
         {
             d5 = tex.getIconVMin();
             d6 = tex.getIconVMax();
@@ -735,10 +738,10 @@ public class RenderBlocks
         double d11 = d6;
         if(uvRotateWest == 1)
         {
-            d3 = tex.getSubIconU(block.minY);
-            d6 = tex.getSubIconV(1 - block.minX);
-            d4 = tex.getSubIconU(block.maxY);
-            d5 = tex.getSubIconV(1 - block.maxX);
+            d3 = tex.getSubIconU(bounds.minY);
+            d6 = tex.getSubIconV(1 - bounds.minX);
+            d4 = tex.getSubIconU(bounds.maxY);
+            d5 = tex.getSubIconV(1 - bounds.maxX);
             d10 = d5;
             d11 = d6;
             d8 = d3;
@@ -748,10 +751,10 @@ public class RenderBlocks
         } else
         if(uvRotateWest == 2)
         {
-            d3 = tex.getSubIconU(1 - block.maxY);
-            d5 = tex.getSubIconV(block.minX);
-            d4 = tex.getSubIconU(1 - block.minY);
-            d6 = tex.getSubIconV(block.maxX);
+            d3 = tex.getSubIconU(1 - bounds.maxY);
+            d5 = tex.getSubIconV(bounds.minX);
+            d4 = tex.getSubIconU(1 - bounds.minY);
+            d6 = tex.getSubIconV(bounds.maxX);
             d8 = d4;
             d9 = d3;
             d3 = d8;
@@ -761,20 +764,20 @@ public class RenderBlocks
         } else
         if(uvRotateWest == 3)
         {
-            d3 = tex.getSubIconU(1 - block.minX);
-            d4 = tex.getSubIconU(1 - block.maxX);
-            d5 = tex.getSubIconV(block.maxY);
-            d6 = tex.getSubIconV(block.minY);
+            d3 = tex.getSubIconU(1 - bounds.minX);
+            d4 = tex.getSubIconU(1 - bounds.maxX);
+            d5 = tex.getSubIconV(bounds.maxY);
+            d6 = tex.getSubIconV(bounds.minY);
             d8 = d4;
             d9 = d3;
             d10 = d5;
             d11 = d6;
         }
-        double x0 = x + block.minX;
-        double x1 = x + block.maxX;
-        double y0 = y + block.minY;
-        double y1 = y + block.maxY;
-        double z0 = z + block.maxZ;
+        double x0 = x + bounds.minX;
+        double x1 = x + bounds.maxX;
+        double y0 = y + bounds.minY;
+        double y1 = y + bounds.maxY;
+        double z0 = z + bounds.maxZ;
         if(enableAO)
         {
         	if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
@@ -798,26 +801,26 @@ public class RenderBlocks
         }
     }
 
-    public void renderWestFace(Tessellator tessellator, Block block, double x, double y, double z, IconCoordinate tex)
+    public void renderWestFace(Tessellator tessellator, AABB bounds, double x, double y, double z, IconCoordinate tex)
     {
         if(overrideBlockTexture != null) tex = overrideBlockTexture;
         if (tex == null) return;
-        double d3 = tex.getSubIconU(block.minZ);
-        double d4 = tex.getSubIconU(block.maxZ);
-        double d5 = tex.getSubIconV(1 - block.maxY);
-        double d6 = tex.getSubIconV(1 - block.minY);
+        double d3 = tex.getSubIconU(bounds.minZ);
+        double d4 = tex.getSubIconU(bounds.maxZ);
+        double d5 = tex.getSubIconV(1 - bounds.maxY);
+        double d6 = tex.getSubIconV(1 - bounds.minY);
         if(flipTexture)
         {
             double d7 = d3;
             d3 = d4;
             d4 = d7;
         }
-        if(block.minZ < 0.0D || block.maxZ > 1.0D)
+        if(bounds.minZ < 0.0D || bounds.maxZ > 1.0D)
         {
             d3 = tex.getIconUMin();
             d4 = tex.getIconUMax();
         }
-        if(block.minY < 0.0D || block.maxY > 1.0D)
+        if(bounds.minY < 0.0D || bounds.maxY > 1.0D)
         {
             d5 = tex.getIconVMin();
             d6 = tex.getIconVMax();
@@ -828,10 +831,10 @@ public class RenderBlocks
         double d11 = d6;
         if(uvRotateNorth == 1)
         {
-            d3 = tex.getSubIconU(block.minY);
-            d5 = tex.getSubIconV(1 - block.maxZ);
-            d4 = tex.getSubIconU(block.maxY);
-            d6 = tex.getSubIconV(1 - block.minZ);
+            d3 = tex.getSubIconU(bounds.minY);
+            d5 = tex.getSubIconV(1 - bounds.maxZ);
+            d4 = tex.getSubIconU(bounds.maxY);
+            d6 = tex.getSubIconV(1 - bounds.minZ);
             d10 = d5;
             d11 = d6;
             d8 = d3;
@@ -841,10 +844,10 @@ public class RenderBlocks
         } else
         if(uvRotateNorth == 2)
         {
-            d3 = tex.getSubIconU(1 - block.maxY);
-            d5 = tex.getSubIconV(block.minZ);
-            d4 = tex.getSubIconU(1 - block.minY);
-            d6 = tex.getSubIconV(block.maxZ);
+            d3 = tex.getSubIconU(1 - bounds.maxY);
+            d5 = tex.getSubIconV(bounds.minZ);
+            d4 = tex.getSubIconU(1 - bounds.minY);
+            d6 = tex.getSubIconV(bounds.maxZ);
             d8 = d4;
             d9 = d3;
             d3 = d8;
